BEGIN TRAN T1

declare @v_field_id numeric(14)
declare @v_dataspy_id numeric(14)
declare @v_col_ord int
declare @DataSpyName varchar(50)
declare @GridName varchar(20)
declare @ExistingDataSpyId numeric(14, 0)
declare @sChk varchar(3);

set @DataSpyName = 'Material List (I/R) - AM'
set @GridName = 'LVIRMATL'

-- Cleanup

if exists
(
    select *
    from r5dddataspy ds
    inner join r5grid g on ds.dds_gridid = g.grd_gridid
    where dds_ddspyname = @DataSpyName
    and g.grd_gridname = @GridName
)
begin

    select @ExistingDataSpyId = ds.dds_ddspyid
    from r5dddataspy ds
    inner join r5grid g on ds.dds_gridid = g.grd_gridid
    where dds_ddspyname = @DataSpyName
    and g.grd_gridname = @GridName
    
    delete from r5queryfield where dqf_ddspyid = @ExistingDataSpyId
    delete from r5dddataspy where dds_ddspyid = @ExistingDataSpyId
end

-- Insert DataSpy and QueryField
    
EXECUTE [dbo].[R5O7_O7MAXSEQ] @v_dataspy_id OUTPUT, 'DDS', '1', @sChk OUTPUT;

insert into R5dddataspy
(
    DDS_DDSPYNAME,
    DDS_DDSPYID,
    DDS_AUTORUN,
    DDS_SCOPE,
    DDS_ORGANIZATION,
    DDS_UPDATESTAMP,
    DDS_UPDATEBYUSER,
    DDS_CREATEDSTAMP,
    DDS_UPDATEABLE,
    DDS_FILTERSTRXML,
    DDS_SORTSTRXML,
    DDS_FIELDLIST,
    DDS_UPDATECOUNT,
    DDS_DISPLAYROW,
    DDS_OWNER,
    DDS_GRIDID,
    DDS_TYPE,
    DDS_DEFAULTFLAG,
    DDS_FIELDLIST_PORTLET,
    DDS_CLIENTROWS,
    DDS_PORTLETROWS,
    DDS_HINTS,
    DDS_BOTNAME,
    DDS_USERFILTER,
    DDS_SECURITYDATASPY,
    DDS_MEKEY
)
select
    @DataSpyName,
    @v_dataspy_id,
    '-',
    '-',
    DDS_ORGANIZATION,
    DDS_UPDATESTAMP,
    DDS_UPDATEBYUSER,
    DDS_CREATEDSTAMP,
    DDS_UPDATEABLE,
    DDS_FILTERSTRXML,
    DDS_SORTSTRXML,
    DDS_FIELDLIST,
    DDS_UPDATECOUNT,
    DDS_DISPLAYROW,
    DDS_OWNER,
    DDS_GRIDID,
    'UD',
    '-',
    DDS_FIELDLIST_PORTLET,
    DDS_CLIENTROWS,
    DDS_PORTLETROWS,
    DDS_HINTS,
    NULL,
    DDS_USERFILTER,
    DDS_SECURITYDATASPY,
    DDS_MEKEY
from R5dddataspy ds, r5grid g
where ds.dds_gridid = g.grd_gridid
and g.grd_gridname = @GridName
and ds.dds_defaultflag = '+';

insert into r5queryfield
(
    DQF_DDSPYID,
    DQF_FIELDID,
    DQF_COLUMNWIDTH,
    DQF_COLUMNORDER,
    DQF_UPDATECOUNT,
    DQF_VIEWTYPE
)
select
    @v_dataspy_id,
    DQF_FIELDID,
    DQF_COLUMNWIDTH,
    DQF_COLUMNORDER,
    DQF_UPDATECOUNT,
    DQF_VIEWTYPE
from r5queryfield q, R5dddataspy ds, r5grid g, r5gridfield gf
where q.dqf_ddspyid = ds.dds_ddspyid
AND ds.dds_gridid = g.grd_gridid
AND q.dqf_fieldid = gf.gfd_fieldid
AND gf.gfd_gridid = g.grd_gridid
and g.grd_gridname = @GridName
and ds.dds_defaultflag = '+'
and q.dqf_viewtype = 'LIST'
order by g.grd_gridname, gf.GFD_BOTNUMBER;

COMMIT TRAN T1